// vi:fdm=marker fdl=0 syntax=xs:
// $Id: GAUL.xs,v 1.9 2004/05/05 13:09:15 jettero Exp $
   
// include matter {{{
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include </usr/local/gaul/include/gaul.h>

#include "const-c.inc"
// }}}

MODULE = AI::GAUL PACKAGE = AI::GAUL

INCLUDE: const-xs.inc

# functions to get onemax.pl working

# random_seed {{{
void
random_seed(i)
    int i

# }}}
# ga_genesis_bitstring {{{
population *
ga_genesis_bitstring(pop_size,num_chromo,len_chromo,gh_cb,ih_cb,dd_cb,dri_cb,e_cb,s_cb,a_cb,so_cb,st_cb,m_cb,c_cb,r_cb)
    int pop_size
    int num_chromo
    int len_chromo
    SV * gh_cb
    SV * ih_cb
    SV * dd_cb
    SV * dri_cb
    SV * e_cb
    SV * s_cb
    SV * a_cb
    SV * so_cb
    SV * st_cb
    SV * m_cb
    SV * c_cb
    SV * r_cb

    CODE:
    RETVAL = ga_genesis_int(
                pop_size,     /* const int              population_size */
                num_chromo,   /* const int              num_chromo */
                len_chromo,   /* const int              len_chromo */
                NULL,         /* GAgeneration_hook      generation_hook */
                NULL,         /* GAiteration_hook       iteration_hook */
                NULL,         /* GAdata_destructor      data_destructor */
                NULL,         /* GAdata_ref_incrementor data_ref_incrementor */
                NULL,         /* GAevaluate             evaluate */
                NULL,         /* GAseed                 seed */
                NULL,         /* GAadapt                adapt */
                NULL,         /* GAselect_one           select_one */
                NULL,         /* GAselect_two           select_two */
                NULL,         /* GAmutate               mutate */
                NULL,         /* GAcrossover            crossover */
                NULL,         /* GAreplace              replace */
                NULL          /* vpointer               User data */
            );

    OUTPUT:
    RETVAL

# }}}
# ga_extinction {{{
void
ga_extinction(pop)
    population * pop

# }}}

# functions to get pingpong.pl working

# ga_genesis_int {{{
population *
ga_genesis_int(pop_size,num_chromo,len_chromo)
    int pop_size
    int num_chromo
    int len_chromo

    CODE:
    RETVAL = ga_genesis_int(
                pop_size,     /* const int              population_size */
                num_chromo,   /* const int              num_chromo */
                len_chromo,   /* const int              len_chromo */
                NULL,         /* GAgeneration_hook      generation_hook */
                NULL,         /* GAiteration_hook       iteration_hook */
                NULL,         /* GAdata_destructor      data_destructor */
                NULL,         /* GAdata_ref_incrementor data_ref_incrementor */
                NULL,         /* GAevaluate             evaluate */
                NULL,         /* GAseed                 seed */
                NULL,         /* GAadapt                adapt */
                NULL,         /* GAselect_one           select_one */
                NULL,         /* GAselect_two           select_two */
                NULL,         /* GAmutate               mutate */
                NULL,         /* GAcrossover            crossover */
                NULL,         /* GAreplace              replace */
                NULL          /* vpointer               User data */
            );

    OUTPUT:
    RETVAL

# }}}

MODULE = AI::GAUL PACKAGE = AI::GAUL::Population
