#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
constant_26 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     GA_ELITISM_PARENTS_SURVIVE GA_ELITISM_RESCORE_PARENTS
     GA_SCHEME_BALDWIN_CHILDREN GA_SCHEME_LAMARCK_CHILDREN */
  /* Offset 16 gives the best switch position.  */
  switch (name[16]) {
  case 'K':
    if (memEQ(name, "GA_SCHEME_LAMARCK_CHILDREN", 26)) {
    /*                               ^                */
#ifdef GA_SCHEME_LAMARCK_CHILDREN
      *iv_return = GA_SCHEME_LAMARCK_CHILDREN;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "GA_SCHEME_BALDWIN_CHILDREN", 26)) {
    /*                               ^                */
#ifdef GA_SCHEME_BALDWIN_CHILDREN
      *iv_return = GA_SCHEME_BALDWIN_CHILDREN;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "GA_ELITISM_RESCORE_PARENTS", 26)) {
    /*                               ^                */
#ifdef GA_ELITISM_RESCORE_PARENTS
      *iv_return = GA_ELITISM_RESCORE_PARENTS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "GA_ELITISM_PARENTS_SURVIVE", 26)) {
    /*                               ^                */
#ifdef GA_ELITISM_PARENTS_SURVIVE
      *iv_return = GA_ELITISM_PARENTS_SURVIVE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw( GA_ELITISM_NULL GA_ELITISM_ONE_PARENT_SURVIVES
	       GA_ELITISM_PARENTS_DIE GA_ELITISM_PARENTS_SURVIVE
	       GA_ELITISM_RESCORE_PARENTS GA_ELITISM_UNKNOWN GA_GENESIS_UNKNOWN
	       GA_SCHEME_BALDWIN_ALL GA_SCHEME_BALDWIN_CHILDREN
	       GA_SCHEME_BALDWIN_PARENTS GA_SCHEME_DARWIN GA_SCHEME_LAMARCK_ALL
	       GA_SCHEME_LAMARCK_CHILDREN GA_SCHEME_LAMARCK_PARENTS));

print constant_types(); # macro defs
foreach (C_constant ("AI::GAUL", 'constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "#### XS Section:\n";
print XS_constant ("AI::GAUL", $types);
__END__
   */

  switch (len) {
  case 0:
    if (name[0] == '') {
#ifdef 
      *iv_return = ;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 15:
    if (memEQ(name, "GA_ELITISM_NULL", 15)) {
#ifdef GA_ELITISM_NULL
      *iv_return = GA_ELITISM_NULL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 16:
    if (memEQ(name, "GA_SCHEME_DARWIN", 16)) {
#ifdef GA_SCHEME_DARWIN
      *iv_return = GA_SCHEME_DARWIN;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 18:
    /* Names all of length 18.  */
    /* GA_ELITISM_UNKNOWN GA_GENESIS_UNKNOWN */
    /* Offset 3 gives the best switch position.  */
    switch (name[3]) {
    case 'E':
      if (memEQ(name, "GA_ELITISM_UNKNOWN", 18)) {
      /*                  ^                     */
#ifdef GA_ELITISM_UNKNOWN
        *iv_return = GA_ELITISM_UNKNOWN;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'G':
      if (memEQ(name, "GA_GENESIS_UNKNOWN", 18)) {
      /*                  ^                     */
#ifdef GA_GENESIS_UNKNOWN
        *iv_return = GA_GENESIS_UNKNOWN;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 21:
    /* Names all of length 21.  */
    /* GA_SCHEME_BALDWIN_ALL GA_SCHEME_LAMARCK_ALL */
    /* Offset 12 gives the best switch position.  */
    switch (name[12]) {
    case 'L':
      if (memEQ(name, "GA_SCHEME_BALDWIN_ALL", 21)) {
      /*                           ^               */
#ifdef GA_SCHEME_BALDWIN_ALL
        *iv_return = GA_SCHEME_BALDWIN_ALL;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'M':
      if (memEQ(name, "GA_SCHEME_LAMARCK_ALL", 21)) {
      /*                           ^               */
#ifdef GA_SCHEME_LAMARCK_ALL
        *iv_return = GA_SCHEME_LAMARCK_ALL;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 22:
    if (memEQ(name, "GA_ELITISM_PARENTS_DIE", 22)) {
#ifdef GA_ELITISM_PARENTS_DIE
      *iv_return = GA_ELITISM_PARENTS_DIE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 25:
    /* Names all of length 25.  */
    /* GA_SCHEME_BALDWIN_PARENTS GA_SCHEME_LAMARCK_PARENTS */
    /* Offset 12 gives the best switch position.  */
    switch (name[12]) {
    case 'L':
      if (memEQ(name, "GA_SCHEME_BALDWIN_PARENTS", 25)) {
      /*                           ^                   */
#ifdef GA_SCHEME_BALDWIN_PARENTS
        *iv_return = GA_SCHEME_BALDWIN_PARENTS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'M':
      if (memEQ(name, "GA_SCHEME_LAMARCK_PARENTS", 25)) {
      /*                           ^                   */
#ifdef GA_SCHEME_LAMARCK_PARENTS
        *iv_return = GA_SCHEME_LAMARCK_PARENTS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 26:
    return constant_26 (aTHX_ name, iv_return);
    break;
  case 30:
    if (memEQ(name, "GA_ELITISM_ONE_PARENT_SURVIVES", 30)) {
#ifdef GA_ELITISM_ONE_PARENT_SURVIVES
      *iv_return = GA_ELITISM_ONE_PARENT_SURVIVES;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

